/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 31/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.StrukturNomor;
import com.portofolio.entity.vo.StrukturNomorId;

@Lazy
@Repository
public interface StrukturNomorMasterDao extends CrudRepository<StrukturNomor, StrukturNomorId> {

	@Cacheable("StrukturNomorDaofindOneBy")
	StrukturNomor findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);

	@Query(QListAll)
	@Cacheable("StrukturNomorDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page,
			@Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and model.namaStrukturNomor like %:namaStrukturNomor% ")
	@Cacheable("StrukturNomorDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaStrukturNomor") String namaStrukturNomor, Pageable page,
			@Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and model.id.kode = :kode")
	@Cacheable("StrukturNomorDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode,
			@Param("kdDepartemen") String kdDepartemen);

	@Modifying
	@Cacheable("setStatusEnabledFalseDao")
	// @Transactional
	@Query("update StrukturNomorDetail m set m.statusEnabled = false where m.id.kdProfile =:kdProfile and m.id.kdStrukturNomor =:KdStrukturNomor ")
	public void setStatusEnabledFalse(@Param("kdProfile") Integer kdProfile,
			@Param("KdStrukturNomor") Integer KdStrukturNomor);

	String QListAll = "select new map(typeDataObjek.namaTypeDataObjek as namaTypeDataObjek,model.id as kode " + ", model.id.kode as kdStrukturNomor " +", model.kdTypeDataObjek as kdTypeDataObjek"
			+ ", model.namaStrukturNomor as namaStrukturNomor " + ", model.reportDisplay as reportDisplay "
			+ ", model.deskripsiDetail as deskripsiDetail " + ", model.kdDepartemen as kdDepartemen "
			+ ", model.isDefault as isDefault " + ", model.qtyDigitNomor as qtyDigitNomor "
			+ ", model.formatNomor as formatNomor " + ", model.isAutoIncrement as isAutoIncrement "
			+ ", model.kdStrukturNomorHead as kdStrukturNomorHead "
			+ ", strukturNomorHead.namaStrukturNomor as namaStrukturNomorHead "
			+ ", model.keteranganLainnya as keteranganLainnya " + ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec " + ", departemen.namaDepartemen as namaDepartemen, model.version as version ,"
			+ " model.qtyPanggilan as qtyPanggilan,"
			+ " model.qtyNomorPastRecall as qtyNomorPastRecall,"
			+ " model.durasiPanggilanMenit as durasiPanggilanMenit,"
			+ " model.isQtyNomorPastRecallByPass as isQtyNomorPastRecallByPass,model.isPanggilanByPass as isPanggilanByPass)"
			+ " from StrukturNomor model left join model.typeDataObjek typeDataObjek left join model.id id left join model.departemen departemen "
			+ " left join model.strukturNomorHead strukturNomorHead "
			+ " left join model.profile profile where profile.kode =:kdProfile and model.kdDepartemen = :kdDepartemen ";
	// + "and model.statusEnabled = true ";

	StrukturNomor findByIdKodeAndIdKdProfile(Integer kdStrukturNomor, Integer kdProfile);
	
	@Query("select new map(model.id as kode " + ", model.id.kode as kdStrukturNomor "
			+ ", model.namaStrukturNomor as namaStrukturNomor " + ", model.reportDisplay as reportDisplay "
			+ ", model.deskripsiDetail as deskripsiDetail " + ", model.kdDepartemen as kdDepartemen "
			+ ", model.isDefault as isDefault " + ", model.qtyDigitNomor as qtyDigitNomor "
			+ ", model.formatNomor as formatNomor " + ", model.isAutoIncrement as isAutoIncrement "
			+ ", model.kdStrukturNomorHead as kdStrukturNomorHead "
			+ ", strukturNomorHead.namaStrukturNomor as namaStrukturNomorHead "
			+ ", model.keteranganLainnya as keteranganLainnya " + ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec " + ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from StrukturNomor model left join model.id id left join model.departemen departemen "
			+ " left join model.strukturNomorHead strukturNomorHead "
			+ " left join model.profile profile where profile.kode =:kdProfile") 
	List<Map<String, Object>> findAllData(@Param("kdProfile") Integer kdProfile);

}
